import pefile
from glob import glob

sec_names = {}

# Loop through all system32 exe files
for f in glob( 'c:\\windows\\system32\\*.exe'):
    try:
        # Create a PE instance, parsing the executable
        pe = pefile.PE( f )
        # Loop through each section
        for s in pe.sections:
            # Append the file to a dictionary keyed by section name
            if sec_names.has_key( s.Name ):
                sec_names[ s.Name ].append( f )
            else:
                        sec_names[ s.Name ] = [ f ]
    except:
        print "Invalid file: ", f

# A lambda function to create a sort key 
len_sort = lambda x: len( sec_names[ x ] )
sorted_names = sorted( sec_names.keys(), key=len_sort, reverse=True )

# print the section names and their frequencies in descending order
for k in sorted_names:
    print "% 8s: %d" % ( k, len( sec_names[ k ] ) )
